*** src/backend/utils/adt/formatting.c
--- src/backend/utils/adt/formatting.c
***************
*** 4663,4671 **** numeric_to_char(PG_FUNCTION_ARGS)
  	}
  	else if (IS_EEEE(&Num))
  	{
! 		orgnum = DatumGetCString(DirectFunctionCall2(numeric_out_sci,
! 											         NumericGetDatum(value),
! 										             Int32GetDatum(Num.post)));
  		/*
  		 * numeric_out_sci() does not emit a sign for positive numbers.  We
  		 * need to add a space in this case so that positive and negative
--- 4663,4670 ----
  	}
  	else if (IS_EEEE(&Num))
  	{
! 		orgnum = numeric_out_sci(value, Num.post);
! 
  		/*
  		 * numeric_out_sci() does not emit a sign for positive numbers.  We
  		 * need to add a space in this case so that positive and negative
*** src/backend/utils/adt/numeric.c
--- src/backend/utils/adt/numeric.c
***************
*** 432,442 **** numeric_out(PG_FUNCTION_ARGS)
   *
   *	Output function for numeric data type in scientific notation.
   */
! Datum
! numeric_out_sci(PG_FUNCTION_ARGS)
  {
- 	Numeric		num = PG_GETARG_NUMERIC(0);
- 	int32		scale = PG_GETARG_INT32(1);
  	NumericVar	x;
  	char	   *str;
  
--- 432,440 ----
   *
   *	Output function for numeric data type in scientific notation.
   */
! char *
! numeric_out_sci(Numeric num, int scale)
  {
  	NumericVar	x;
  	char	   *str;
  
***************
*** 444,457 **** numeric_out_sci(PG_FUNCTION_ARGS)
  	 * Handle NaN
  	 */
  	if (NUMERIC_IS_NAN(num))
! 		PG_RETURN_CSTRING(pstrdup("NaN"));
  
  	init_var(&x);
  	set_var_from_num(num, &x);
  
  	str = get_str_from_var_sci(&x, scale);
  	free_var(&x);
! 	PG_RETURN_CSTRING(str);
  }
  
  /*
--- 442,455 ----
  	 * Handle NaN
  	 */
  	if (NUMERIC_IS_NAN(num))
! 		return pstrdup("NaN");
  
  	init_var(&x);
  	set_var_from_num(num, &x);
  
  	str = get_str_from_var_sci(&x, scale);
  	free_var(&x);
! 	return str;
  }
  
  /*
*** src/include/utils/builtins.h
--- src/include/utils/builtins.h
***************
*** 918,924 **** extern Datum int4_avg_accum(PG_FUNCTION_ARGS);
  extern Datum int8_avg(PG_FUNCTION_ARGS);
  extern Datum width_bucket_numeric(PG_FUNCTION_ARGS);
  extern Datum hash_numeric(PG_FUNCTION_ARGS);
- extern Datum numeric_out_sci(PG_FUNCTION_ARGS);
  
  /* ri_triggers.c */
  extern Datum RI_FKey_check_ins(PG_FUNCTION_ARGS);
--- 918,923 ----
*** src/include/utils/numeric.h
--- src/include/utils/numeric.h
***************
*** 84,87 **** typedef NumericData *Numeric;
--- 84,92 ----
  #define PG_GETARG_NUMERIC_COPY(n) DatumGetNumericCopy(PG_GETARG_DATUM(n))
  #define PG_RETURN_NUMERIC(x)	  return NumericGetDatum(x)
  
+ /*
+  * Utility functions in numeric.c.
+  */
+ extern char *numeric_out_sci(Numeric num, int scale);
+ 
  #endif   /* _PG_NUMERIC_H_ */
